#include <pspkernel.h>
#include <pspsdk.h>
#include <psppower.h>
#include <pspctrl.h>
#include <pspsysevent.h>
#include <stdbool.h>

PSP_MODULE_INFO("SuspendProtect", PSP_MODULE_KERNEL, 1, 0);

clock_t count;

int Callback_Suspend(int ev_id, char *ev_name, void *param, int *result)
{
	if(ev_id == 0x100){	//X[v悤ƂƂ
		if(sceKernelLibcClock() - count <= 1000000)	//ԗĂȂ-1ԂăX[v
			return -1;
	}

	return 0;
}

int main_thread(SceSize args, void *argp)
{
	SceCtrlData pad;

	PspSysEventHandler events;
	events.size			= 0x40;
	events.name			= "MSE_Suspend";
	events.type_mask	= 0x0000FF00;
	events.handler		= Callback_Suspend;
	
	sceKernelRegisterSysEventHandler(&events);

	count = sceKernelLibcClock();

	while(1){
		sceCtrlPeekBufferPositive(&pad, 1);

		if(pad.Buttons & PSP_CTRL_HOLD)
			count = sceKernelLibcClock();

		sceKernelDelayThread(1000);
	}

	return 0;
}

int module_start(SceSize args, void *argp)
{
	int thid = sceKernelCreateThread("SuspendProtect", main_thread, 32, 0x800, 0, NULL);
	if(thid >= 0)
		sceKernelStartThread(thid, args, argp);

	return 0;
}

int module_stop(SceSize args, void *argp)
{
	return 0;
}
